> For the complete documentation index, see [llms.txt](https://docs.reflexer.finance/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.reflexer.finance/system-contracts/automation-module/esm-threshold-setter.md).

# ESM Threshold Setter

## 1. Summary <a href="#id-1-introduction-summary" id="id-1-introduction-summary"></a>

The `ESMThresholdSetter` is meant to recompute the `threshold` of protocol tokens needed to burn and trigger settlement through the `ESM`.

## 2. Contract Variables & Functions <a href="#id-2-contract-details" id="id-2-contract-details"></a>

**Variables**

* `authorizedAccounts[usr: address]` - addresses allowed to call `modifyParameters()` and `disableContract()`.
* `minAmountToBurn` - the minimum amount of protocol tokens that must be burned to trigger settlement using the ESM
* `supplyPercentageToBurn` - the percentage of outstanding protocol tokens to burn in order to trigger settlement using the ESM
* `protocolToken` - The address of the protocol token
* `esm` - the address of the ESM contract

**Functions**

* `modifyParameters` - modify contract parameters
* `recomputeThreshold` - calculate and set a new protocol token threshold in the ESM

**Modifiers**

* `isAuthorized` - checks whether an address is part of `authorizedAddresses` (and thus can call authed functions).

**Events**

* `AddAuthorization` - emitted when a new address becomes authorized. Contains:
  * `account` - the new authorized account
* `RemoveAuthorization` - emitted when an address is de-authorized. Contains:
  * `account` - the address that was de-authorized
* `ModifyParameters` - emitted when a parameter is updated.

## 3. Walkthrough <a href="#id-2-contract-details" id="id-2-contract-details"></a>

`recomputeThreshold` can be called any time in order to recompute the threshold inside the `esm`. The computed threshold must be higher than or equal to `minAmountToBurn` and it should be a specific percentage of the outstanding supply of protocol tokens.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.reflexer.finance/system-contracts/automation-module/esm-threshold-setter.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
